/*
   Original Author: bbum

   Copyright 1999 by CodeFab, Inc.   All rights reserved.

   This notice may not be removed from this source code.
   The use and distribution of this software is governed by the
   terms of the MiscKit license agreement.  Refer to the license
   document included with the MiscKit distribution for the terms.
   Details of the license agreement may be found at
   www.misckit.com or within the MiscKit distribution.

   There may be more information about this software on
   www.codefab.com.  Send queries to ask_codefab@codefab.com.
*/


#import "EngineExample.h"

@implementation EngineExample
- init
{
    self = [super init];

    userName = nil;
    likesBroccoli = YES; // benefit of the doubt
    
    return self;
}

- (void) dealloc
{
    [userName release];
    userName = nil;

    [super dealloc];
}

- (NSString *) userName; { return userName; }
- (void) setUserName: (NSString *) aName; {
    if (aName != userName) {
        [userName release];
        userName = [aName retain];
    }
}

- (BOOL) likesBroccoli; { return likesBroccoli; }
- (void) setLikesBroccoli: (BOOL) aFlag; { likesBroccoli = aFlag; }

- (NSException *) validateUserName: (NSString *) possibleName
{
    if ([possibleName isEqualToString: @"Amy"] == YES)
        return [NSException validationExceptionWithFormat: @"Sorry, Amy, but you aren't allowed to express an opinion about Broccoli."];

    return nil;
}

@end
